Solid Edge Part Type Library
AddSimple Method
Specifies the number of sections to be used to construct the lofted feature. This value is equal to the count of CrossSections, CrossSectionTypes, and Origins.
Contains Edge and/or Profile objects. The size of the array is equal to the value of NumSections.
Contains members of the FeaturePropertyConstants set (igProfileBasedCrossSection and igEdgeBasedCrossSection) that specify whether each corresponding member of the CrossSections array is an Edge or Profile object. The size of the array is equal to the value of NumSections.
Contains the points that define the start points of the corresponding cross sections. Each point is represented as an array of two Doubles (for example, Dim dblOrigin(2) as Double; Dim Origins() as Variant). For members of this array that correspond to periodic cross sections (circles and ellipses), specify a value of 0 instead of an array that represents a point.
Set this value to igLeft.
Set this value to igNone.
Set this value to igNone.
Description
Adds a LoftedCutout or LoftedProtrusion object.
Syntax
Visual Basic
Public Function AddSimple( _
   ByVal NumSections As Long, _
   ByVal CrossSections As Variant, _
   ByVal CrossSectionTypes As Variant, _
   ByVal Origins As Variant, _
   ByVal MaterialSide As FeaturePropertyConstants, _
   ByVal StartTangentType As FeaturePropertyConstants, _
   ByVal EndTangentType As FeaturePropertyConstants, _
   Optional ByVal NumGuideCurves As Variant, _
   Optional ByVal GuideCurves As Variant _
) As LoftedCutout
Parameters
NumSections
Specifies the number of sections to be used to construct the lofted feature. This value is equal to the count of CrossSections, CrossSectionTypes, and Origins.
CrossSections
Contains Edge and/or Profile objects. The size of the array is equal to the value of NumSections.
CrossSectionTypes
Contains members of the FeaturePropertyConstants set (igProfileBasedCrossSection and igEdgeBasedCrossSection) that specify whether each corresponding member of the CrossSections array is an Edge or Profile object. The size of the array is equal to the value of NumSections.
Origins
Contains the points that define the start points of the corresponding cross sections. Each point is represented as an array of two Doubles (for example, Dim dblOrigin(2) as Double; Dim Origins() as Variant). For members of this array that correspond to periodic cross sections (circles and ellipses), specify a value of 0 instead of an array that represents a point.
MaterialSide
ValueDescription
igAddRound
igAll
igAlongAnAxis
igAngularDummy
igAsConstruction
igBend
igBendAndFaceCornerRelief
igBendOnlyCornerRelief
igBothFeature Properties - Both
igChainedCornerRelief
igChamfer2Setbacks
igChamfer45degSetback
igChamferAngleSetback
igCircular
igCloseCornerCircleCutout
igCloseCornerClosed
igCloseCornerNone
igCloseCornerOpen
igClosed
igCloseFaces
igConcave
igConstantRadiusArc
igConstRadiusRound
igContinuous
igConvex
igCopy
igCornerRound
igCounterboreHole
igCounterboreProfileIsAtBottom
igCounterboreProfileIsAtTop
igCounterdrillHole
igCountersinkHole
igCurvatureContinuous
igCurvatureContinuousInterior
igCurveSetSeperator
igDeleteFaceHeal
igDelSMFaceBoth
igDelSMFaceNone
igDelSystemRelief
igDelZeroBendRadius
igDevelopableSurface
igEdgeBasedCrossSection
igEdgesByLoop
igEdgesByVertex
igEnd
igEndCaps
igEqualOffset
igEquationType
igExtendFeature Properties - Extend
igExtendBendRelief
igFacesTouchingCurvesOnly
igFilletBendRelief
igFinite
igFlangeCenterOfEdge
igFlangeEndFromEndEdge
igFlangeEndOnEndEdge
igFlangeFromBothEndsOfEdge
igFlangeFromDefinedStartPoint
igFlangeFullEdge
igFlangeMatchFace
igFlangeOffset
igFlangeStartFromEndEdge
igFlangeStartOnEndEdge
igFlatten
igFormedEnd
igFromNonReferenceEnd
igFromReferenceEnd
igFromTo
igFull
igGroove
igHemTypeCenteredLoop
igHemTypeClosed
igHemTypeClosedLoop
igHemTypeCurl
igHemTypeOpen
igHemTypeOpenLoop
igHemTypeSFlange
igIgnoreBlends
igInsideFeature Properties - Remove/Add Material Inside
igInsideDimension
igIntersect
igLancedEnd
igLeftFeature Properties - Project to Left
igLinear
igLinearCurvatureContinuousExtension
igLinearTangentExtension
igLip
igLouverFormedEndType
igLouverLancedEndType
igLouverRound
igLouverRoundNone
igMitreByAngle
igMitreByDist
igMitreManufacturingCut
igMitreNormalToThickness
igMitreParallelToThickness
igMitreRegularCut
igMove
igMultipleEdges
igNatural
igNeutralFactorFromExcel
igNFType
igNoCornerRound
igNoExtendFeature Properties - Do Not Extend
igNone
igNonSymmetric
igNormal
igNormalSideDummyFeature Properties - Normal Side
igNoRound
igNullConstant
igOffset
igOutsideFeature Properties - Remove/Add Material Outside
igOutsideDimension
igOverlapFaces
igParallelDummy
igParallelToPlane
igPartingFromCurve
igPartingFromEdge
igPartingFromPlane
igPartingFromSurface
igPatternAlongCurve
igPatternCircular
igPatternFillRegion
igPatternMirror
igPatternMountingBoss
igPatternRectangular
igPatternUserDefined
igPeriodic
igProfileBasedCrossSection
igProjectOptionProject
igProjectOptionWrap
igPunchedEnd
igRadial
igRaisedCounterboreSlot
igRecessedCounterboreSlot
igRecreateBlends
igRectangularBendRelief
igReflective
igRegularHole
igRegularSlot
igRegularThread
igRemoveBoundaries
igRemoveExternalBoundaries
igRemoveInternalBoundaries
igReverseNormal
igReverseNormalSideDummyFeature Properties - Reverse Normal Side
igRightFeature Properties - Project to Right
igRipBendRelief
igRipCornerRelief
igRndCapAcrossSharpEdges
igRndMiterAtCorner
igRndPreserveTopologyOff
igRndPreserveTopologyOn
igRndRollAcrossSharpEdges
igRndRollAcrossTangentEdgesOff
igRndRollAcrossTangentEdgesOn
igRndRollAlongBlendEdgesOff
igRndRollAlongBlendEdgesOn
igRndRollAroundCorner
igRoundAllVertexSetback
igRoundEndVertexEdgeSetback
igRoundSetbackIsAbsolute
igRoundSetbackIsRelative
igRoundSingleVertexSetback
igRoundStartVertexEdgeSetback
igRoundVertexEdgeSetback
igShowBoundaries
igSideInfoSetSeperator
igSingleEdge
igSMClearanceCutout
igSMFaceCutout
igSMMidPlaneCutout
igSplit
igSplitAngle1Left
igSplitAngle1Right
igSplitDraft
igStart
igStepDraft
igStepDraftPerpendicular
igStraightPipeThread
igSubtract
igSweepAlignArcLength
igSweepAlignNormal
igSweepAlignParallel
igSweepAlignParametrically
igSweepC1Continuity
igSweepC2Continuity
igSweepMergeAll
igSweepMergeAlongPath
igSweepMergeNone
igSweepScaleNone
igSweepScaleStartAndEnd
igSweepTwistNone
igSweepTwistStartAndEnd
igSweepTwistTurns
igSweepTwistTurnsPerUnitLength
igSymmetricFeature Properties - Symmetric Extent
igTangent
igTangentInterior
igTaperByAngle
igTaperByRatio
igTaperByRLRatio
igTaperDimAtBottom
igTaperDimAtTop
igTaperedEnd
igTaperedHole
igTaperedPipeThread
igTaperedToPlane
igTappedHole
igThickness
igThkInProfilePlane
igThkNormalToProfilePlane
igThreeHundredAndSixty
igThroughAll
igThroughAxis
igToEndOfEdge
igToggleToConstructionToggle from Design to Construction
igToggleToDesignToggle from Construction to Design
igToKeyPoint
igToNext
igTreatmentCircleCutout
igTreatmentCrown
igTreatmentDraft
igTreatmentFormedFeatureDisplayAsCenterMark
igTreatmentFormedFeatureDisplayAsModeled
igTreatmentFormedFeatureDisplayAsSketch
igTreatmentFormedFeatureDisplayAsSketchAndCenterMark
igTreatmentIntersect
igTreatmentMiterRelief
igTreatmentOff
igTreatmentRectangularCutout
igTreatmentUCutout
igTreatmentVCutout
igUnequalOffset
igUnite
igUShaped
igVarRadiusRound
igVBottomDimToFlat
igVBottomDimToV
igVShaped
igWeldGrooveCapProject
igWeldGrooveCapSameAsTop
igWeldGrooveCapSurface
Set this value to igLeft.
StartTangentType
ValueDescription
igAddRound
igAll
igAlongAnAxis
igAngularDummy
igAsConstruction
igBend
igBendAndFaceCornerRelief
igBendOnlyCornerRelief
igBothFeature Properties - Both
igChainedCornerRelief
igChamfer2Setbacks
igChamfer45degSetback
igChamferAngleSetback
igCircular
igCloseCornerCircleCutout
igCloseCornerClosed
igCloseCornerNone
igCloseCornerOpen
igClosed
igCloseFaces
igConcave
igConstantRadiusArc
igConstRadiusRound
igContinuous
igConvex
igCopy
igCornerRound
igCounterboreHole
igCounterboreProfileIsAtBottom
igCounterboreProfileIsAtTop
igCounterdrillHole
igCountersinkHole
igCurvatureContinuous
igCurvatureContinuousInterior
igCurveSetSeperator
igDeleteFaceHeal
igDelSMFaceBoth
igDelSMFaceNone
igDelSystemRelief
igDelZeroBendRadius
igDevelopableSurface
igEdgeBasedCrossSection
igEdgesByLoop
igEdgesByVertex
igEnd
igEndCaps
igEqualOffset
igEquationType
igExtendFeature Properties - Extend
igExtendBendRelief
igFacesTouchingCurvesOnly
igFilletBendRelief
igFinite
igFlangeCenterOfEdge
igFlangeEndFromEndEdge
igFlangeEndOnEndEdge
igFlangeFromBothEndsOfEdge
igFlangeFromDefinedStartPoint
igFlangeFullEdge
igFlangeMatchFace
igFlangeOffset
igFlangeStartFromEndEdge
igFlangeStartOnEndEdge
igFlatten
igFormedEnd
igFromNonReferenceEnd
igFromReferenceEnd
igFromTo
igFull
igGroove
igHemTypeCenteredLoop
igHemTypeClosed
igHemTypeClosedLoop
igHemTypeCurl
igHemTypeOpen
igHemTypeOpenLoop
igHemTypeSFlange
igIgnoreBlends
igInsideFeature Properties - Remove/Add Material Inside
igInsideDimension
igIntersect
igLancedEnd
igLeftFeature Properties - Project to Left
igLinear
igLinearCurvatureContinuousExtension
igLinearTangentExtension
igLip
igLouverFormedEndType
igLouverLancedEndType
igLouverRound
igLouverRoundNone
igMitreByAngle
igMitreByDist
igMitreManufacturingCut
igMitreNormalToThickness
igMitreParallelToThickness
igMitreRegularCut
igMove
igMultipleEdges
igNatural
igNeutralFactorFromExcel
igNFType
igNoCornerRound
igNoExtendFeature Properties - Do Not Extend
igNone
igNonSymmetric
igNormal
igNormalSideDummyFeature Properties - Normal Side
igNoRound
igNullConstant
igOffset
igOutsideFeature Properties - Remove/Add Material Outside
igOutsideDimension
igOverlapFaces
igParallelDummy
igParallelToPlane
igPartingFromCurve
igPartingFromEdge
igPartingFromPlane
igPartingFromSurface
igPatternAlongCurve
igPatternCircular
igPatternFillRegion
igPatternMirror
igPatternMountingBoss
igPatternRectangular
igPatternUserDefined
igPeriodic
igProfileBasedCrossSection
igProjectOptionProject
igProjectOptionWrap
igPunchedEnd
igRadial
igRaisedCounterboreSlot
igRecessedCounterboreSlot
igRecreateBlends
igRectangularBendRelief
igReflective
igRegularHole
igRegularSlot
igRegularThread
igRemoveBoundaries
igRemoveExternalBoundaries
igRemoveInternalBoundaries
igReverseNormal
igReverseNormalSideDummyFeature Properties - Reverse Normal Side
igRightFeature Properties - Project to Right
igRipBendRelief
igRipCornerRelief
igRndCapAcrossSharpEdges
igRndMiterAtCorner
igRndPreserveTopologyOff
igRndPreserveTopologyOn
igRndRollAcrossSharpEdges
igRndRollAcrossTangentEdgesOff
igRndRollAcrossTangentEdgesOn
igRndRollAlongBlendEdgesOff
igRndRollAlongBlendEdgesOn
igRndRollAroundCorner
igRoundAllVertexSetback
igRoundEndVertexEdgeSetback
igRoundSetbackIsAbsolute
igRoundSetbackIsRelative
igRoundSingleVertexSetback
igRoundStartVertexEdgeSetback
igRoundVertexEdgeSetback
igShowBoundaries
igSideInfoSetSeperator
igSingleEdge
igSMClearanceCutout
igSMFaceCutout
igSMMidPlaneCutout
igSplit
igSplitAngle1Left
igSplitAngle1Right
igSplitDraft
igStart
igStepDraft
igStepDraftPerpendicular
igStraightPipeThread
igSubtract
igSweepAlignArcLength
igSweepAlignNormal
igSweepAlignParallel
igSweepAlignParametrically
igSweepC1Continuity
igSweepC2Continuity
igSweepMergeAll
igSweepMergeAlongPath
igSweepMergeNone
igSweepScaleNone
igSweepScaleStartAndEnd
igSweepTwistNone
igSweepTwistStartAndEnd
igSweepTwistTurns
igSweepTwistTurnsPerUnitLength
igSymmetricFeature Properties - Symmetric Extent
igTangent
igTangentInterior
igTaperByAngle
igTaperByRatio
igTaperByRLRatio
igTaperDimAtBottom
igTaperDimAtTop
igTaperedEnd
igTaperedHole
igTaperedPipeThread
igTaperedToPlane
igTappedHole
igThickness
igThkInProfilePlane
igThkNormalToProfilePlane
igThreeHundredAndSixty
igThroughAll
igThroughAxis
igToEndOfEdge
igToggleToConstructionToggle from Design to Construction
igToggleToDesignToggle from Construction to Design
igToKeyPoint
igToNext
igTreatmentCircleCutout
igTreatmentCrown
igTreatmentDraft
igTreatmentFormedFeatureDisplayAsCenterMark
igTreatmentFormedFeatureDisplayAsModeled
igTreatmentFormedFeatureDisplayAsSketch
igTreatmentFormedFeatureDisplayAsSketchAndCenterMark
igTreatmentIntersect
igTreatmentMiterRelief
igTreatmentOff
igTreatmentRectangularCutout
igTreatmentUCutout
igTreatmentVCutout
igUnequalOffset
igUnite
igUShaped
igVarRadiusRound
igVBottomDimToFlat
igVBottomDimToV
igVShaped
igWeldGrooveCapProject
igWeldGrooveCapSameAsTop
igWeldGrooveCapSurface
Set this value to igNone.
EndTangentType
ValueDescription
igAddRound
igAll
igAlongAnAxis
igAngularDummy
igAsConstruction
igBend
igBendAndFaceCornerRelief
igBendOnlyCornerRelief
igBothFeature Properties - Both
igChainedCornerRelief
igChamfer2Setbacks
igChamfer45degSetback
igChamferAngleSetback
igCircular
igCloseCornerCircleCutout
igCloseCornerClosed
igCloseCornerNone
igCloseCornerOpen
igClosed
igCloseFaces
igConcave
igConstantRadiusArc
igConstRadiusRound
igContinuous
igConvex
igCopy
igCornerRound
igCounterboreHole
igCounterboreProfileIsAtBottom
igCounterboreProfileIsAtTop
igCounterdrillHole
igCountersinkHole
igCurvatureContinuous
igCurvatureContinuousInterior
igCurveSetSeperator
igDeleteFaceHeal
igDelSMFaceBoth
igDelSMFaceNone
igDelSystemRelief
igDelZeroBendRadius
igDevelopableSurface
igEdgeBasedCrossSection
igEdgesByLoop
igEdgesByVertex
igEnd
igEndCaps
igEqualOffset
igEquationType
igExtendFeature Properties - Extend
igExtendBendRelief
igFacesTouchingCurvesOnly
igFilletBendRelief
igFinite
igFlangeCenterOfEdge
igFlangeEndFromEndEdge
igFlangeEndOnEndEdge
igFlangeFromBothEndsOfEdge
igFlangeFromDefinedStartPoint
igFlangeFullEdge
igFlangeMatchFace
igFlangeOffset
igFlangeStartFromEndEdge
igFlangeStartOnEndEdge
igFlatten
igFormedEnd
igFromNonReferenceEnd
igFromReferenceEnd
igFromTo
igFull
igGroove
igHemTypeCenteredLoop
igHemTypeClosed
igHemTypeClosedLoop
igHemTypeCurl
igHemTypeOpen
igHemTypeOpenLoop
igHemTypeSFlange
igIgnoreBlends
igInsideFeature Properties - Remove/Add Material Inside
igInsideDimension
igIntersect
igLancedEnd
igLeftFeature Properties - Project to Left
igLinear
igLinearCurvatureContinuousExtension
igLinearTangentExtension
igLip
igLouverFormedEndType
igLouverLancedEndType
igLouverRound
igLouverRoundNone
igMitreByAngle
igMitreByDist
igMitreManufacturingCut
igMitreNormalToThickness
igMitreParallelToThickness
igMitreRegularCut
igMove
igMultipleEdges
igNatural
igNeutralFactorFromExcel
igNFType
igNoCornerRound
igNoExtendFeature Properties - Do Not Extend
igNone
igNonSymmetric
igNormal
igNormalSideDummyFeature Properties - Normal Side
igNoRound
igNullConstant
igOffset
igOutsideFeature Properties - Remove/Add Material Outside
igOutsideDimension
igOverlapFaces
igParallelDummy
igParallelToPlane
igPartingFromCurve
igPartingFromEdge
igPartingFromPlane
igPartingFromSurface
igPatternAlongCurve
igPatternCircular
igPatternFillRegion
igPatternMirror
igPatternMountingBoss
igPatternRectangular
igPatternUserDefined
igPeriodic
igProfileBasedCrossSection
igProjectOptionProject
igProjectOptionWrap
igPunchedEnd
igRadial
igRaisedCounterboreSlot
igRecessedCounterboreSlot
igRecreateBlends
igRectangularBendRelief
igReflective
igRegularHole
igRegularSlot
igRegularThread
igRemoveBoundaries
igRemoveExternalBoundaries
igRemoveInternalBoundaries
igReverseNormal
igReverseNormalSideDummyFeature Properties - Reverse Normal Side
igRightFeature Properties - Project to Right
igRipBendRelief
igRipCornerRelief
igRndCapAcrossSharpEdges
igRndMiterAtCorner
igRndPreserveTopologyOff
igRndPreserveTopologyOn
igRndRollAcrossSharpEdges
igRndRollAcrossTangentEdgesOff
igRndRollAcrossTangentEdgesOn
igRndRollAlongBlendEdgesOff
igRndRollAlongBlendEdgesOn
igRndRollAroundCorner
igRoundAllVertexSetback
igRoundEndVertexEdgeSetback
igRoundSetbackIsAbsolute
igRoundSetbackIsRelative
igRoundSingleVertexSetback
igRoundStartVertexEdgeSetback
igRoundVertexEdgeSetback
igShowBoundaries
igSideInfoSetSeperator
igSingleEdge
igSMClearanceCutout
igSMFaceCutout
igSMMidPlaneCutout
igSplit
igSplitAngle1Left
igSplitAngle1Right
igSplitDraft
igStart
igStepDraft
igStepDraftPerpendicular
igStraightPipeThread
igSubtract
igSweepAlignArcLength
igSweepAlignNormal
igSweepAlignParallel
igSweepAlignParametrically
igSweepC1Continuity
igSweepC2Continuity
igSweepMergeAll
igSweepMergeAlongPath
igSweepMergeNone
igSweepScaleNone
igSweepScaleStartAndEnd
igSweepTwistNone
igSweepTwistStartAndEnd
igSweepTwistTurns
igSweepTwistTurnsPerUnitLength
igSymmetricFeature Properties - Symmetric Extent
igTangent
igTangentInterior
igTaperByAngle
igTaperByRatio
igTaperByRLRatio
igTaperDimAtBottom
igTaperDimAtTop
igTaperedEnd
igTaperedHole
igTaperedPipeThread
igTaperedToPlane
igTappedHole
igThickness
igThkInProfilePlane
igThkNormalToProfilePlane
igThreeHundredAndSixty
igThroughAll
igThroughAxis
igToEndOfEdge
igToggleToConstructionToggle from Design to Construction
igToggleToDesignToggle from Construction to Design
igToKeyPoint
igToNext
igTreatmentCircleCutout
igTreatmentCrown
igTreatmentDraft
igTreatmentFormedFeatureDisplayAsCenterMark
igTreatmentFormedFeatureDisplayAsModeled
igTreatmentFormedFeatureDisplayAsSketch
igTreatmentFormedFeatureDisplayAsSketchAndCenterMark
igTreatmentIntersect
igTreatmentMiterRelief
igTreatmentOff
igTreatmentRectangularCutout
igTreatmentUCutout
igTreatmentVCutout
igUnequalOffset
igUnite
igUShaped
igVarRadiusRound
igVBottomDimToFlat
igVBottomDimToV
igVShaped
igWeldGrooveCapProject
igWeldGrooveCapSameAsTop
igWeldGrooveCapSurface
Set this value to igNone.
NumGuideCurves
GuideCurves
Example
Private Sub Form_Load()
    Dim objApp As SolidEdgeFramework.Application
    Dim objDoc As SolidEdgePart.PartDocument
    Dim objRefPlane As SolidEdgePart.RefPlane
    Dim objProfiles(1 To 3) As SolidEdgePart.Profile
    Dim objLines As SolidEdgeFrameworkSupport.Lines2d
    Dim objRelations As SolidEdgeFrameworkSupport.Relations2d
    Dim objLine(1 To 4) As SolidEdgeFrameworkSupport.Line2d
    Dim objBaseLines As SolidEdgeFrameworkSupport.Lines2d
    Dim objBaseProfile(1 To 2) As SolidEdgePart.Profile
    Dim objBaseRelns As SolidEdgeFrameworkSupport.Relations2d
    Dim objModel As SolidEdgePart.Model
    Dim objLoftCut As SolidEdgePart.LoftedCutout
    Dim objLoftCuts As SolidEdgePart.LoftedCutouts
    Dim lngStatus As Long
    Dim xOrigin As Double, yOrigin As Double
    Dim OriginArray(1 To 3) As Variant
    Dim Origin(1 To 2) As Double
    Dim SectionTypes(1 To 3) As Long
    Dim i As Integer
    ' Report errors
    Const PI = 3.14159265358979
    ' Create/get the application with specific settings
    On Error Resume Next
    Set objApp = GetObject(, "SolidEdge.Application")
    If Err Then
        Err.Clear
        Set objApp = CreateObject("SolidEdge.Application")
        Set objDoc = objApp.Documents.Add("SolidEdge.PartDocument")
        objApp.Visible = True
    Else
        Set objDoc = objApp.ActiveDocument
    End If
    On Error GoTo 0
    ' Draw the Base Profile
    Set objBaseProfile(1) = objDoc.ProfileSets.Add.Profiles.Add(pRefPlaneDisp:= _
                                                                objDoc.RefPlanes(1))
    Set objBaseLines = objBaseProfile(1).Lines2d
    Call objBaseLines.AddBy2Points(x1:=0, y1:=0, x2:=0.1, y2:=0)
    Call objBaseLines.AddBy2Points(x1:=0.1, y1:=0, x2:=0.1, y2:=0.1)
    Call objBaseLines.AddBy2Points(x1:=0.1, y1:=0.1, x2:=0, y2:=0.1)
    Call objBaseLines.AddBy2Points(x1:=0, y1:=0.1, x2:=0, y2:=0)
    ' Define Relations among the Line objects to make the Profile closed
    Set objBaseRelns = objBaseProfile(1).Relations2d
    Call objBaseRelns.AddKeypoint(Object1:=objBaseLines(1), Index1:=igLineEnd, Object2:= _
                                  objBaseLines(2), Index2:=igLineStart)
    Call objBaseRelns.AddKeypoint(Object1:=objBaseLines(2), Index1:=igLineEnd, Object2:= _
                                  objBaseLines(3), Index2:=igLineStart)
    Call objBaseRelns.AddKeypoint(Object1:=objBaseLines(3), Index1:=igLineEnd, Object2:= _
                                  objBaseLines(4), Index2:=igLineStart)
    Call objBaseRelns.AddKeypoint(Object1:=objBaseLines(4), Index1:=igLineEnd, Object2:= _
                                  objBaseLines(1), Index2:=igLineStart)

    ' Check for the Profile Validity
    lngStatus = objBaseProfile(1).End(ValidationCriteria:=igProfileClosed)
    If lngStatus <> 0 Then
        MsgBox ("Profile not closed")
    End If
    'Create the Base Extruded Protrusion Feature
    Set objModel = objDoc.Models.AddFiniteExtrudedProtrusion(NumberOfProfiles:=1, _
                                                             ProfileArray:=objBaseProfile, _
                                                             ProfilePlaneSide:=igRight, _
                                                             ExtrusionDistance:=0.1)
    objBaseProfile(1).Visible = False
    ' Check the status of Base Feature
    If objModel.ExtrudedProtrusions(1).Status <> igFeatureOK Then
        MsgBox ("Error in the Creation of Base Protrusion Feature object")
    End If
    ' Create a Lofted Cutout object
    ' Create a new reference plane.
    Set objRefPlane = objDoc.RefPlanes.AddParallelByDistance( _
                      ParentPlane:=objDoc.RefPlanes(2), Distance:=0.1, _
                      NormalSide:=igRight, Local:=True)
    ' Create a new profile set and profile to use for the first section.
    Set objProfiles(1) = objDoc.ProfileSets.Add.Profiles.Add(pRefPlaneDisp:= _
                                                             objRefPlane)
    ' Get the model space origin relative to profile space.
    Call objProfiles(1).Convert3DCoordinate(x3d:=0, y3d:=0, z3d:=0, _
                                            x2d:=xOrigin, y2d:=yOrigin)
    ' Save the coordinates to define the start point for this profile.
    Origin(1) = 0.03
    Origin(2) = 0.03
    OriginArray(1) = Origin
    ' Set a reference to the Lines2d and Relations2d collections on the profile.
    Set objLines = objProfiles(1).Lines2d
    Set objRelations = objProfiles(1).Relations2d
    ' Draw 4 lines for the Rectangular profile graphics.
    Set objLine(1) = objLines.AddBy2Points(x1:=0.03, y1:=0.03, x2:=0.07, _
                                           y2:=0.03)
    Set objLine(2) = objLines.AddBy2Points(x1:=0.07, y1:=0.03, _
                                           x2:=0.07, y2:=0.07)
    Set objLine(3) = objLines.AddBy2Points(x1:=0.07, y1:=0.07, _
                                           x2:=0.03, y2:=0.07)
    Set objLine(4) = objLines.AddBy2Points(x1:=0.03, y1:=0.07, _
                                           x2:=0.03, y2:=0.03)
    ' Connect the lines with relationships
    Call objRelations.AddKeypoint(Object1:=objLine(1), Index1:=igLineEnd, Object2:= _
                                  objLine(2), Index2:=igLineStart)
    Call objRelations.AddKeypoint(Object1:=objLine(2), Index1:=igLineEnd, Object2:= _
                                  objLine(3), Index2:=igLineStart)
    Call objRelations.AddKeypoint(Object1:=objLine(3), Index1:=igLineEnd, Object2:= _
                                  objLine(4), Index2:=igLineStart)
    Call objRelations.AddKeypoint(Object1:=objLine(4), Index1:=igLineEnd, Object2:= _
                                  objLine(1), Index2:=igLineStart)
    ' End and validate the profile.
    lngStatus = objProfiles(1).End(ValidationCriteria:=igProfileClosed)
    If lngStatus <> 0 Then
        MsgBox (" Invalid Profile")
    End If
    ' Turn off the display of the profile.
    objProfiles(1).Visible = False
    ' Create a new reference plane.
    Set objRefPlane = objDoc.RefPlanes.AddParallelByDistance( _
                      ParentPlane:=objDoc.RefPlanes(2), Distance:=0.05, _
                      NormalSide:=igRight, Local:=True)
    ' Create a new profile set and profile to use for the first section.
    Set objProfiles(2) = objDoc.ProfileSets.Add.Profiles.Add(pRefPlaneDisp:=objRefPlane)
    ' Get the model space origin relative to profile space.
    Call objProfiles(2).Convert3DCoordinate(x3d:=0, y3d:=0, z3d:=0, _
                                            x2d:=xOrigin, y2d:=yOrigin)
    ' Save the coordinates to define the start point for this profile.
    Origin(1) = xOrigin
    Origin(2) = yOrigin
    OriginArray(2) = Origin
    ' Draw a circle.
    Call objProfiles(2).Circles2d.AddByCenterRadius(x:=0.05, y:= _
                                                    0.05, Radius:=0.015)
    ' End and validate the profile.
    lngStatus = objProfiles(2).End(ValidationCriteria:=igProfileClosed)
    If lngStatus <> 0 Then
        MsgBox ("Invalid Profile")
    End If
    ' Turn off the display of the profile.
    objProfiles(2).Visible = False
    ' Create a new reference plane.
    Set objRefPlane = objDoc.RefPlanes.AddParallelByDistance( _
                      ParentPlane:=objDoc.RefPlanes(2), Distance:=0, _
                      NormalSide:=igRight, Local:=True)
    ' Create a new profile set and profile to use for the first section.
    Set objProfiles(3) = objDoc.ProfileSets.Add.Profiles.Add(pRefPlaneDisp:= _
                                                             objRefPlane)
    ' Get the model space origin relative to profile space.
    Call objProfiles(3).Convert3DCoordinate(x3d:=0, y3d:=0, z3d:=0, _
                                            x2d:=xOrigin, y2d:=yOrigin)
    ' Save the coordinates to define the start point for this profile.
    Origin(1) = 0.03
    Origin(2) = 0.03
    OriginArray(3) = Origin
    ' Set a reference to the Lines2d and Relations2d collections on the profile.
    Set objLines = objProfiles(3).Lines2d
    Set objRelations = objProfiles(3).Relations2d
    ' Draw 4 lines for the Rectangular profile graphics.
    Set objLine(1) = objLines.AddBy2Points(x1:=0.03, y1:=0.03, x2:=0.07, _
                                           y2:=0.03)
    Set objLine(2) = objLines.AddBy2Points(x1:=0.07, y1:=0.03, _
                                           x2:=0.07, y2:=0.07)
    Set objLine(3) = objLines.AddBy2Points(x1:=0.07, y1:=0.07, _
                                           x2:=0.03, y2:=0.07)
    Set objLine(4) = objLines.AddBy2Points(x1:=0.03, y1:=0.07, _
                                           x2:=0.03, y2:=0.03)
    ' Connect the lines with relationships
    Call objRelations.AddKeypoint(Object1:=objLine(1), Index1:=igLineEnd, Object2:= _
                                  objLine(2), Index2:=igLineStart)
    Call objRelations.AddKeypoint(Object1:=objLine(2), Index1:=igLineEnd, Object2:= _
                                  objLine(3), Index2:=igLineStart)
    Call objRelations.AddKeypoint(Object1:=objLine(3), Index1:=igLineEnd, Object2:= _
                                  objLine(4), Index2:=igLineStart)
    Call objRelations.AddKeypoint(Object1:=objLine(4), Index1:=igLineEnd, Object2:= _
                                  objLine(1), Index2:=igLineStart)
    ' End and validate the profile.
    lngStatus = objProfiles(3).End(ValidationCriteria:=igProfileClosed)
    If lngStatus <> 0 Then
        MsgBox ("Invalid Profile")
    End If
    ' Turn off the display of the profile.
    objProfiles(3).Visible = False
    For i = 1 To 3
        SectionTypes(i) = igProfileBasedCrossSection
    Next
    ' Build up an array of the origin positions.
    Set objLoftCut = objDoc.Models(1).LoftedCutouts.AddSimple(NumSections:=3, CrossSections:=objProfiles, _
                                                              CrossSectionTypes:=SectionTypes, Origins:=OriginArray, _
                                                              MaterialSide:=igLeft, StartTangentType:=igNone, _
                                                              EndTangentType:=igNone)




    ' USER DISPLAY
    ' Release objects
    Set objApp = Nothing
    Set objDoc = Nothing
    Set objRefPlane = Nothing
    Set objProfiles(1) = Nothing
    Set objProfiles(2) = Nothing
    Set objProfiles(3) = Nothing
    Set objLine(1) = Nothing
    Set objLine(2) = Nothing
    Set objLine(3) = Nothing
    Set objLine(4) = Nothing
    Set objRelations = Nothing
    Set objLines = Nothing
    Set objBaseProfile(1) = Nothing
    Set objBaseLines = Nothing
    Set objBaseRelns = Nothing
    Set objModel = Nothing
    Set objLoftCut = Nothing
    Set objLoftCuts = Nothing
End Sub
See Also

LoftedCutouts Collection  | LoftedCutouts Members